Index: keys.c
===================================================================
--- keys.c	(revision 3004c9f7ea88e3888e2d6a71cbf552f9f9f84afb)
+++ keys.c	(revision ce561499ae34e2491909f1b4059182b7381b9f04)
@@ -50,6 +50,8 @@
 
   BIND_CMD("LEFT",        "edit:move-left", "");
+  BIND_CMD("M-[ D",       "edit:move-left", "");
   BIND_CMD("C-b",         "edit:move-left", "");
   BIND_CMD("RIGHT",       "edit:move-right", "");
+  BIND_CMD("M-[ C",       "edit:move-right", "");
   BIND_CMD("C-f",         "edit:move-right", "");
 
@@ -65,10 +67,12 @@
   BIND_CMD("M-DELETE",    "edit:delete-prev-word", "");
   BIND_CMD("M-d",         "edit:delete-next-word", "");
+  BIND_CMD("M-DC",        "edit:delete-next-word", "");
   BIND_CMD("M-[ 3 ; 3 ~", "edit:delete-next-word", "");
 
   BIND_CMD("C-h",         "edit:delete-prev-char", "");
   BIND_CMD("BACKSPACE",   "edit:delete-prev-char", "");
-  BIND_CMD("DC",          "edit:delete-prev-char", "");
   BIND_CMD("DELETE",      "edit:delete-prev-char", "");
+  BIND_CMD("C-d",         "edit:delete-next-char", "");
+  BIND_CMD("DC",          "edit:delete-next-char", "");
 
   BIND_CMD("C-k",         "edit:delete-to-line-end", "");
@@ -79,6 +83,4 @@
 
   BIND_CMD("C-l",         "( edit:recenter ; redisplay )", "");
-
-  BIND_CMD("C-d",     "edit:delete-next-char", "");
 
 
@@ -93,6 +95,8 @@
 
   BIND_CMD("UP",      "editmulti:move-up-line", "");
+  BIND_CMD("M-[ A",   "editmulti:move-up-line", "");
   BIND_CMD("C-p",     "editmulti:move-up-line", "");
   BIND_CMD("DOWN",    "editmulti:move-down-line", "");
+  BIND_CMD("M-[ B",   "editmulti:move-down-line", "");
   BIND_CMD("C-n",     "editmulti:move-down-line", "");
 
@@ -120,8 +124,10 @@
 
   BIND_CMD("UP",          "edit:history-prev", "");
+  BIND_CMD("M-[ A",       "edit:history-prev", "");
   BIND_CMD("C-p",         "edit:history-prev", "");
   BIND_CMD("M-p",         "edit:history-prev", "");
 
   BIND_CMD("DOWN",        "edit:history-next", "");
+  BIND_CMD("M-[ B",       "edit:history-next", "");
   BIND_CMD("C-n",         "edit:history-next", "");
   BIND_CMD("M-n",         "edit:history-next", "");
@@ -166,7 +172,9 @@
   BIND_CMD("LF",          "popless:scroll-down-line", "");
   BIND_CMD("DOWN",        "popless:scroll-down-line", "");
+  BIND_CMD("M-[ B",       "popless:scroll-down-line", "");
   BIND_CMD("C-n",         "popless:scroll-down-line", "");
 
   BIND_CMD("UP",          "popless:scroll-up-line", "");
+  BIND_CMD("M-[ A",       "popless:scroll-up-line", "");
   BIND_CMD("C-h",         "popless:scroll-up-line", "");
   BIND_CMD("C-p",         "popless:scroll-up-line", "");
@@ -176,5 +184,7 @@
 
   BIND_CMD("RIGHT",       "popless:scroll-right 10", "scrolls right");
+  BIND_CMD("M-[ C",       "popless:scroll-right 10", "scrolls right");
   BIND_CMD("LEFT",        "popless:scroll-left  10", "scrolls left");
+  BIND_CMD("M-[ D",       "popless:scroll-left  10", "scrolls left");
 
   BIND_CMD("HOME",        "popless:scroll-to-top", "");
@@ -232,5 +242,5 @@
   BIND_CMD("M-[ D",  "recv:shiftleft", "");
   BIND_CMD("RIGHT",  "recv:shiftright","");
-  BIND_CMD("M-[ C",  "recv:shiftleft", "");
+  BIND_CMD("M-[ C",  "recv:shiftright","");
   BIND_CMD("DOWN",   "recv:next",      "");
   BIND_CMD("C-n",    "recv:next",      "");
@@ -282,6 +292,4 @@
   BIND_CMD("M-r", "reply -e",         "reply to the current message, but allow editing of recipient");
   BIND_CMD("M-R", "reply -e sender",  "reply to sender of the current message, but allow editing of recipient");
-		  
-  BIND_CMD("w",   "openurl",          "open a URL using a webbrowser");
 
   BIND_CMD("W",   "start-command webzephyr ", "start a webzephyr command");
Index: list.c
===================================================================
--- list.c	(revision 50622a59357b6958f78b136d6d25ce31540f7c59)
+++ list.c	(revision f34dd65b3adbc2eedc045a674dd89b7e20257680)
@@ -78,13 +78,4 @@
 }
 
-/* todo: might leak memory */
-int owl_list_replace_element(owl_list *l, int n, void *element)
-{
-  if (n>l->size-1) return(-1);
-
-  l->list[n]=element;
-  return(0);
-}
-
 void owl_list_free_all(owl_list *l, void (*elefree)(void *))
 {
Index: message.c
===================================================================
--- message.c	(revision 147d88077919720ae7689914594bbda67e87d83b)
+++ message.c	(revision f34dd65b3adbc2eedc045a674dd89b7e20257680)
@@ -338,16 +338,4 @@
 }
 
-/* caller must free the return */
-char *owl_message_get_shorttimestr(owl_message *m)
-{
-  struct tm *tmstruct;
-  char *out;
-
-  tmstruct=localtime(&(m->time));
-  out=owl_sprintf("%2.2i:%2.2i", tmstruct->tm_hour, tmstruct->tm_min);
-  if (out) return(out);
-  return("??:??");
-}
-
 void owl_message_set_type_admin(owl_message *m)
 {
@@ -384,10 +372,4 @@
 {
   return owl_message_is_type(m, "admin");
-}
-
-int owl_message_is_type_generic(owl_message *m)
-{
-  char * t = owl_message_get_attribute_value(m, "type");
-  return (t == NULL);
 }
 
@@ -573,40 +555,8 @@
 }
 
-int owl_message_is_from_me(owl_message *m)
-{
-  if (owl_message_is_type_zephyr(m)) {
-    if (!strcasecmp(owl_message_get_sender(m), owl_zephyr_get_sender())) {
-      return(1);
-    } else {
-      return(0);
-    }
-  } else if (owl_message_is_type_aim(m)) {
-    if (!strcasecmp(owl_message_get_sender(m), owl_global_get_aim_screenname(&g))) {
-      return(1);
-    } else {
-      return(0);
-    }
-  } else if (owl_message_is_type_admin(m)) {
-    return(0);
-  }
-  return(0);
-}
-
 int owl_message_is_mail(owl_message *m)
 {
   if (owl_message_is_type_zephyr(m)) {
     if (!strcasecmp(owl_message_get_class(m), "mail") && owl_message_is_private(m)) {
-      return(1);
-    } else {
-      return(0);
-    }
-  }
-  return(0);
-}
-
-int owl_message_is_ping(owl_message *m)
-{
-  if (owl_message_is_type_zephyr(m)) {
-    if (!strcasecmp(owl_message_get_opcode(m), "ping")) {
       return(1);
     } else {
@@ -964,6 +914,8 @@
   owl_message_set_instance(m, owl_zwrite_get_instance(&z));
   if (owl_zwrite_get_numrecips(&z)>0) {
+    char *longzuser = long_zuser(owl_zwrite_get_recip_n(&z, 0));
     owl_message_set_recipient(m,
-			      long_zuser(owl_zwrite_get_recip_n(&z, 0))); /* only gets the first user, must fix */
+			      longzuser); /* only gets the first user, must fix */
+    owl_free(longzuser);
   }
   owl_message_set_opcode(m, owl_zwrite_get_opcode(&z));
@@ -990,14 +942,4 @@
 }
 
-void owl_message_pretty_zsig(owl_message *m, char *buff)
-{
-  /* stick a one line version of the zsig in buff */
-  char *ptr;
-
-  strcpy(buff, owl_message_get_zsig(m));
-  ptr=strchr(buff, '\n');
-  if (ptr) ptr[0]='\0';
-}
-
 void owl_message_free(owl_message *m)
 {
Index: owl.c
===================================================================
--- owl.c	(revision c1d2e6c253c25bace704f5d9d9171396524ae595)
+++ owl.c	(revision 28fa23c1162940f75a7e835c9c19de7eac3e33b5)
@@ -46,5 +46,5 @@
   int newmsgs, nexttimediff;
   struct sigaction sigact;
-  char *configfile, *tty, *perlout, *perlerr, **argvsave, buff[LINE], startupmsg[LINE];
+  char *configfile, *tty, *perlout, *perlerr, **argvsave;
   char *confdir;
   owl_filter *f;
@@ -55,8 +55,5 @@
   struct termios tio;
   owl_message *m;
-#if OWL_STDERR_REDIR
-  int newstderr;
-#endif
-  
+
   if (!GLIB_CHECK_VERSION (2, 12, 0))
     g_error ("GLib version 2.12.0 or above is needed.");
@@ -191,5 +188,5 @@
     d->fd = STDIN;
     d->cfunc = &owl_process_input;
-    d->pfunc = NULL;
+    d->destroy = NULL;
     owl_select_add_dispatch(d);
   }
@@ -202,5 +199,5 @@
     d->fd = ZGetFD();
     d->cfunc = &owl_zephyr_process_events;
-    d->pfunc = NULL;
+    d->destroy = NULL;
     owl_select_add_dispatch(d);
     owl_global_set_havezephyr(&g);
@@ -211,9 +208,13 @@
 #if OWL_STDERR_REDIR
   /* Do this only after we've started curses up... */
-  owl_function_debugmsg("startup: doing stderr redirection");
-  newstderr = stderr_replace();
-  owl_muxevents_add(owl_global_get_muxevents(&g), newstderr, OWL_MUX_READ,
-		    stderr_redirect_handler, NULL);
-#endif   
+  {
+    owl_dispatch *d = owl_malloc(sizeof(owl_dispatch));
+    owl_function_debugmsg("startup: doing stderr redirection");
+    d->fd = stderr_replace();
+    d->cfunc = stderr_redirect_handler;
+    d->destroy = NULL;
+    owl_select_add_dispatch(d);
+  }
+#endif
 
   /* create the owl directory, in case it does not exist */
@@ -320,15 +321,15 @@
   /* welcome message */
   owl_function_debugmsg("startup: creating splash message");
-  strcpy(startupmsg, "-----------------------------------------------------------------------\n");
-  sprintf(buff,      "Welcome to barnowl version %s.  Press 'h' for on-line help.            \n", OWL_VERSION_STRING);
-  strcat(startupmsg, buff);
-  strcat(startupmsg, "                                                                       \n");
-  strcat(startupmsg, "BarnOwl is free software. Type ':show license' for more                \n");
-  strcat(startupmsg, "information.                                                           \n");
-  strcat(startupmsg, "                                                                 ^ ^   \n");
-  strcat(startupmsg, "                                                                 OvO   \n");
-  strcat(startupmsg, "Please report any bugs or suggestions to bug-barnowl@mit.edu    (   )  \n");
-  strcat(startupmsg, "-----------------------------------------------------------------m-m---\n");
-  owl_function_adminmsg("", startupmsg);
+  owl_function_adminmsg("",
+    "-----------------------------------------------------------------------\n"
+    "Welcome to barnowl version " OWL_VERSION_STRING ".  Press 'h' for on-line help.\n"
+    "To see a quick introduction, type ':show quickstart'.                  \n"
+    "                                                                       \n"
+    "BarnOwl is free software. Type ':show license' for more                \n"
+    "information.                                                     ^ ^   \n"
+    "                                                                 OvO   \n"
+    "Please report any bugs or suggestions to bug-barnowl@mit.edu    (   )  \n"
+    "-----------------------------------------------------------------m-m---\n"
+  );
   sepbar(NULL);
 
@@ -395,9 +396,11 @@
   nexttime=time(NULL);
 
-#ifdef HAVE_LIBZEPHYR
-  /* Check for any zephyrs that have come in while we've done init. */
-  owl_zephyr_process_events();
-#endif
-  
+
+  owl_select_add_timer(180, 180, owl_zephyr_buddycheck_timer, NULL, NULL);
+
+  /* If we ever deprecate the mainloop hook, remove this. */
+  owl_select_add_timer(0, 1, owl_perlconfig_mainloop, NULL, NULL);
+
+
   owl_function_debugmsg("startup: entering main loop");
   /* main loop */
@@ -414,6 +417,4 @@
 
     followlast=owl_global_should_followlast(&g);
-    
-    owl_perlconfig_mainloop();
 
     /* little hack */
@@ -442,16 +443,4 @@
     }
 
-    /* is it time to check zbuddies? */
-    if (owl_global_is_pseudologins(&g)) {
-      if (owl_timer_is_expired(owl_global_get_zephyr_buddycheck_timer(&g))) {
-	owl_function_debugmsg("Doing zephyr buddy check");
-	owl_function_zephyr_buddy_check(1);
-	owl_timer_reset(owl_global_get_zephyr_buddycheck_timer(&g));
-      }
-    }
-
-    /* dispatch any muxevents */
-    owl_muxevents_dispatch(owl_global_get_muxevents(&g), 0);
-
     /* follow the last message if we're supposed to */
     if (newmsgs && followlast) {
@@ -511,5 +500,5 @@
       int signum;
       if ((signum = owl_global_get_errsignal_and_clear(&g, &si)) > 0) {
-	owl_function_error("Got unexpected signal: %d %s  (code: %d band: %d  errno: %d)", 
+	owl_function_error("Got unexpected signal: %d %s  (code: %d band: %ld  errno: %d)",
 			   signum, signum==SIGPIPE?"SIGPIPE":"SIG????",
 			   si.si_code, si.si_band, si.si_errno);
@@ -614,19 +603,5 @@
 }
 
-void owl_process_aim()
-{
-  if (owl_global_is_doaimevents(&g)) {
-    owl_aim_process_events();
-    
-    if (owl_global_is_aimloggedin(&g)) {
-      if (owl_timer_is_expired(owl_global_get_aim_buddyinfo_timer(&g))) {
-        /* owl_buddylist_request_idletimes(owl_global_get_buddylist(&g)); */
-        owl_timer_reset(owl_global_get_aim_buddyinfo_timer(&g));
-      }
-    }
-  }
-}
-
-void owl_process_input()
+void owl_process_input(owl_dispatch *d)
 {
   int ret;
@@ -773,9 +748,9 @@
 
 /* Sends stderr (read from rfd) messages to the error console */
-void stderr_redirect_handler(int handle, int rfd, int eventmask, void *data) 
+void stderr_redirect_handler(owl_dispatch *d)
 {
   int navail, bread;
-  char *buf;
-  /*owl_function_debugmsg("stderr_redirect: called with rfd=%d\n", rfd);*/
+  char buf[4096];
+  int rfd = d->fd;
   if (rfd<0) return;
   if (-1 == ioctl(rfd, FIONREAD, (void*)&navail)) {
@@ -783,14 +758,22 @@
   }
   /*owl_function_debugmsg("stderr_redirect: navail = %d\n", navail);*/
-  if (navail<=0) return;
-  if (navail>256) { navail = 256; }
-  buf = owl_malloc(navail+1);
+  if (navail <= 0) return;
+  if (navail > sizeof(buf)-1) {
+    navail = sizeof(buf)-1;
+  }
   bread = read(rfd, buf, navail);
   if (buf[navail-1] != '\0') {
     buf[navail] = '\0';
   }
-  owl_function_error("Err: %s", buf);
-  owl_free(buf);
+  owl_function_error("[stderr]\n%s", buf);
 }
 
 #endif /* OWL_STDERR_REDIR */
+
+void owl_zephyr_buddycheck_timer(owl_timer *t, void *data)
+{
+  if (owl_global_is_pseudologins(&g)) {
+    owl_function_debugmsg("Doing zephyr buddy check");
+    owl_function_zephyr_buddy_check(1);
+  }
+}
Index: owl.h
===================================================================
--- owl.h	(revision 43a306cdd965ba39eebeb9f3ccf426f700e34876)
+++ owl.h	(revision f34dd65b3adbc2eedc045a674dd89b7e20257680)
@@ -320,6 +320,6 @@
 
 typedef struct _owl_pair {
-  void *key;
-  void *value;
+  char *key;
+  char *value;
 } owl_pair;
 
@@ -377,14 +377,5 @@
   int active;
   int needsfirstrefresh;
-  void (*handler) (int ch);
 } owl_popwin;
-
-typedef struct _owl_popexec {
-  int refcount;
-  owl_viewwin *vwin;
-  int winactive;
-  int pid;			/* or 0 if it has terminated */
-  int rfd;  
-} owl_popexec;
 
 typedef struct _owl_messagelist {
@@ -412,5 +403,4 @@
 typedef struct _owl_filter {
   char *name;
-  int polarity;
   owl_filterelement * root;
   int fgcolor;
@@ -453,14 +443,4 @@
 } owl_editwin;
 
-typedef struct _owl_mux {
-  int handle;			/* for referencing this */
-  int active;			/* has this been deleted? */
-  int fd;		       
-  int eventmask;		/* bitmask of OWL_MUX_* */
-  void (*handler_fn)(int handle, int fd, int eventmask, void *data);
-  void *data;			/* data reference to pass to callback */
-} owl_mux;
-typedef owl_list owl_muxevents;
-
 typedef struct _owl_keybinding {
   int  *j;			/* keypress stack (0-terminated) */  
@@ -505,7 +485,9 @@
 
 typedef struct _owl_timer {
-  int direction;
-  time_t starttime;
-  int start;
+  time_t time;
+  int interval;
+  void (*callback)(struct _owl_timer *, void *);
+  void (*destroy)(struct _owl_timer *);
+  void *data;
 } owl_timer;
 
@@ -524,8 +506,18 @@
 
 typedef struct _owl_dispatch {
-  int fd;           /* FD to watch for dispatch. */
-  void (*cfunc)();  /* C function to dispatch to. */
-  SV *pfunc;        /* Perl function to dispatch to. */
+  int fd;                                 /* FD to watch for dispatch. */
+  int needs_gc;
+  void (*cfunc)(struct _owl_dispatch*);   /* C function to dispatch to. */
+  void (*destroy)(struct _owl_dispatch*); /* Destructor */
+  void *data;
 } owl_dispatch;
+
+typedef struct _owl_popexec {
+  int refcount;
+  owl_viewwin *vwin;
+  int winactive;
+  int pid;			/* or 0 if it has terminated */
+  owl_dispatch dispatch;
+} owl_popexec;
 
 typedef struct _owl_global {
@@ -537,5 +529,4 @@
   owl_list filterlist;
   owl_list puntlist;
-  owl_muxevents muxevents;	/* fds to dispatch on */
   owl_vardict vars;
   owl_cmddict cmds;
@@ -583,5 +574,4 @@
   owl_timer aim_noop_timer;
   owl_timer aim_ignorelogin_timer;
-  owl_timer aim_buddyinfo_timer;
   int aim_loggedin;         /* true if currently logged into AIM */
   int aim_doprocessing;     /* true if we should process AIM events (like pending login) */
@@ -594,4 +584,5 @@
   int havezephyr;
   int haveaim;
+  int ignoreaimlogin;
   int got_err_signal;	    /* 1 if we got an unexpected signal */
   siginfo_t err_signal_info;
@@ -601,4 +592,6 @@
   owl_obarray obarray;
   owl_list dispatchlist;
+  GList *timerlist;
+  owl_timer *aim_nop_timer;
 } owl_global;
 
Index: pair.c
===================================================================
--- pair.c	(revision 160ea47d4619a2f544022ad89e83dbc934674d61)
+++ pair.c	(revision de1c8a59c19d33ab73607ff6539f55d51088ec6b)
@@ -1,22 +1,22 @@
 #include "owl.h"
 
-void owl_pair_create(owl_pair *p, void *key, void *value) {
+void owl_pair_create(owl_pair *p, char *key, char *value) {
   p->key=key;
   p->value=value;
 }
 
-void owl_pair_set_key(owl_pair *p, void *key) {
+void owl_pair_set_key(owl_pair *p, char *key) {
   p->key=key;
 }
 
-void owl_pair_set_value(owl_pair *p, void *value) {
+void owl_pair_set_value(owl_pair *p, char *value) {
   p->value=value;
 }
 
-void *owl_pair_get_key(owl_pair *p) {
+char *owl_pair_get_key(owl_pair *p) {
   return(p->key);
 }
 
-void *owl_pair_get_value(owl_pair *p) {
+char *owl_pair_get_value(owl_pair *p) {
   return(p->value);
 }
Index: perl/modules/IRC/lib/BarnOwl/Message/IRC.pm
===================================================================
--- perl/modules/IRC/lib/BarnOwl/Message/IRC.pm	(revision 38a7f226a2a038aae5b96d2b47874fa30b6b0ed8)
+++ perl/modules/IRC/lib/BarnOwl/Message/IRC.pm	(revision f79d6a2ccedcc7110b1391f385fb739e324562bd)
@@ -33,6 +33,6 @@
         @filter  =
              (qw{( type ^irc$ and filter personal and },
-              qw{( ( direction ^in$ and sender}, "^$who\$",
-              qw{ ) or ( direction ^out$ and recipient}, "^$who\$",
+              qw{( ( direction ^in$ and sender}, "^\Q$who\E\$",
+              qw{ ) or ( direction ^out$ and recipient}, "^\Q$who\E\$",
               qw{) ) ) });
         BarnOwl::command("filter", "$filter", @filter);
@@ -47,12 +47,12 @@
             $filter = "irc-$network-channel-$channel-$sender-$1";
             @filter =
-                 (qw{type ^irc$ and network}, "^$network\$",
-                  qw{and channel}, "^$channel\$",
-                  qw{and ( sender}, "^$sender\$",
-                  qw{or sender}, "^$1\$",qq{)});
+                 (qw{type ^irc$ and network}, "^\Q$network\E\$",
+                  qw{and channel}, "^\Q$channel\E\$",
+                  qw{and ( sender}, "^\Q$sender\E\$",
+                  qw{or sender}, "^\Q$1\E\$",qq{)});
         } else {
             $filter = "irc-$network-channel-$channel";
-            @filter = (qw{type ^irc$ and network}, "^$network\$",
-                       qw{and channel}, "^$channel\$");
+            @filter = (qw{type ^irc$ and network}, "^\Q$network\E\$",
+                       qw{and channel}, "^\Q$channel\E\$");
         }
         BarnOwl::command("filter", "$filter", @filter);
Index: perl/modules/IRC/lib/BarnOwl/Module/IRC.pm
===================================================================
--- perl/modules/IRC/lib/BarnOwl/Module/IRC.pm	(revision 167044bea49b17d131f1846e1e5528ef58e1c159)
+++ perl/modules/IRC/lib/BarnOwl/Module/IRC.pm	(revision 56d018933b753ce1293b3f7b8f96e664cc9e06b3)
@@ -214,5 +214,5 @@
     if ($body =~ /^\/me (.*)/) {
         $conn->conn->me($to, $1);
-        $body = BarnOwl::Style::boldify($conn->nick.' '.$1);
+        $body = '* '.$conn->nick.' '.$1;
     } else {
         $conn->conn->privmsg($to, $body);
Index: perl/modules/IRC/lib/BarnOwl/Module/IRC/Connection.pm
===================================================================
--- perl/modules/IRC/lib/BarnOwl/Module/IRC/Connection.pm	(revision 4789b17987d2032fcf895ce27b81ac613343e169)
+++ perl/modules/IRC/lib/BarnOwl/Module/IRC/Connection.pm	(revision 3048f1f1ca1c5d195114af9c9dcdc8dc80da65a8)
@@ -107,5 +107,5 @@
     my $nick = $self->nick;
     BarnOwl::beep() if $body =~ /\b\Q$nick\E\b/;
-    $body = BarnOwl::Style::boldify($evt->nick.' '.$body) if $evt->type eq 'caction';
+    $body = '* '.$evt->nick.' '.$body if $evt->type eq 'caction';
     my $msg = $self->new_message($evt,
         direction   => 'in',
Index: perl/modules/Jabber/lib/BarnOwl/Message/Jabber.pm
===================================================================
--- perl/modules/Jabber/lib/BarnOwl/Message/Jabber.pm	(revision 96134cb4aa5cfc151dbc860357af5a7156025c86)
+++ perl/modules/Jabber/lib/BarnOwl/Message/Jabber.pm	(revision 9375f8c6437069cd5e17a476685a9e7b280aa9a5)
@@ -70,5 +70,5 @@
         $filter = "jabber-room-$room";
         BarnOwl::command(qw[filter], $filter,
-                         qw[type ^jabber$ and room], "^$room\$");
+                         qw[type ^jabber$ and room], "^\Q$room\E\$");
         return $filter;
     } elsif ($self->login ne 'none') {
@@ -84,6 +84,6 @@
     my $filter = "jabber-user-$user";
     BarnOwl::command(qw[filter], $filter, qw[type ^jabber$],
-                     qw[and ( ( direction ^in$ and from], "^$user",
-                     qw[) or ( direction ^out$ and to ], "^$user",
+                     qw[and ( ( direction ^in$ and from], "^\Q$user\E(/.*)?\$",
+                     qw[) or ( direction ^out$ and to ], "^\Q$user\E(/.*)?\$",
                      qw[ ) ) ]);
     return $filter;
Index: perl/modules/Jabber/lib/BarnOwl/Module/Jabber.pm
===================================================================
--- perl/modules/Jabber/lib/BarnOwl/Module/Jabber.pm	(revision e979da9926f59c32e4a380c936551b11683cfe94)
+++ perl/modules/Jabber/lib/BarnOwl/Module/Jabber.pm	(revision b73ce70657f6a0da0aab9573fc0844ed89527136)
@@ -70,4 +70,5 @@
         $BarnOwl::Hooks::mainLoop->add("BarnOwl::Module::Jabber::onMainLoop");
         $BarnOwl::Hooks::getBuddyList->add("BarnOwl::Module::Jabber::onGetBuddyList");
+        $BarnOwl::Hooks::getQuickstart->add("BarnOwl::Module::Jabber::onGetQuickstart");
         $vars{show} = '';
 	BarnOwl::new_variable_bool("jabber:show_offline_buddies",
@@ -222,4 +223,14 @@
 }
 
+sub onGetQuickstart {
+    return <<'EOF'
+@b(Jabber:)
+Type ':jabberlogin @b(username@mit.edu)' to log in to Jabber. The command
+':jroster sub @b(somebody@gmail.com)' will request that they let you message
+them. Once you get a message saying you are subscribed, you can message
+them by typing ':jwrite @b(somebody@gmail.com)' or just 'j @b(somebody)'.
+EOF
+}
+
 ################################################################################
 ### Owl Commands
@@ -435,4 +446,5 @@
 
 sub cmd_logout {
+    return "You are not logged into jabber." unless ($conn->connected() > 0);
     # Logged into multiple accounts
     if ( $conn->connected() > 1 ) {
@@ -1112,5 +1124,5 @@
 sub process_presence_subscribed {
     my ( $sid, $p ) = @_;
-    queue_admin_msg("ignoring:".$p->GetXML());
+    queue_admin_msg("ignoring:".$p->GetXML()) if BarnOwl::getvar('jabber:spew') eq 'on';
     # RFC 3921 says we should respond to this with a "subscribe"
     # but this causes a flood of sub/sub'd presence packets with
@@ -1122,5 +1134,5 @@
 sub process_presence_unsubscribed {
     my ( $sid, $p ) = @_;
-    queue_admin_msg("ignoring:".$p->GetXML());
+    queue_admin_msg("ignoring:".$p->GetXML()) if BarnOwl::getvar('jabber:spew') eq 'on';
     # RFC 3921 says we should respond to this with a "subscribe"
     # but this causes a flood of unsub/unsub'd presence packets with
